#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "defs.h"
#include "gif.h"


// global
typedef enum {GM_BG2, GM_PST} GM_ENUM;

GIF_PALETTE_S glb_palette,
              glb_non_alleg;
GIF_RGB_S     glb_colormap[116][32];
PALETTE       glb_alleg_palette;
BITMAP        * glb_buffer,
              * glb_cmap,
              * glb_sprite,
              * glb_sprite_8bpp,
              * glb_sub_preview;
int           glb_colors_1[7] = {0, 0, 0, 0, 0, 0, 0},
              glb_colors_2[21] = {
                  0, 0, 0, 0, 0, 0, 0,
                  0, 0, 0, 0, 0, 0, 0,
                  0, 0, 0, 0, 0, 0, 0
              },
              glb_colors_3[8] = {0, 0, 0, 0, 0, 0, 0, 0}, // ps:t
              glb_curr_col = 0,
              glb_curr_frame = 0,
              glb_curr_zoom;

char glb_strings[28][20] =
{
   {"color A1"},
   {"color A2"},
   {"color A3"},
   {"color A4"},
   {"color A5"},
   {"color A6"},
   {"color A7"},

   {"color B1"},
   {"color B2"},
   {"color B3"},
   {"color B4"},
   {"color B5"},
   {"color B6"},
   {"color B7"},
   {"color B8"},
   {"color B9"},
   {"color B10"},
   {"color B11"},
   {"color B12"},
   {"color B13"},
   {"color B14"},
   {"color B15"},
   {"color B16"},
   {"color B17"},
   {"color B18"},
   {"color B19"},
   {"color B20"},
   {"color B21"}
};

char glb_strings_pst[8][20] =
{
   // 4 16-level gradients
   {"color A1"},
   {"color A2"},
   {"color A3"},
   {"color A4"},

   // 4 32-level gradients
   {"color B1"},
   {"color B2"},
   {"color B3"},
   {"color B4"}
};

// ==========================================================================
void remap_pixels(GIF_ANIM_S * g)
{
   int x, y, f, cmap[256], c, cr, cg, cb, p, i, found, last;

printf("gif_anim = %p\n", g);
fflush(stdout);

printf("# frame  = %i\n", g->num_frames);
fflush(stdout);

   for (f=0; f < g->num_frames; f++)
   {

printf("\nframe %i\n", f); fflush(stdout);

      // search nb colors used in the image (to know last index)
      last = 0;
      for (y=0; y < g->frame[f].height; y++)
      {
         for (x=0; x < g->frame[f].width; x++)
         {
            c = getpixel(g->frame[f].bmp, x, y);
            if (c > last)
               last = c;
         }
      }

      // make a temp colormap to remap local palette to global palette
      for (c=0; c <= last; c++)
      {

printf("   color %i  --> ", c); fflush(stdout);

         // get this local color
         p = g->frame[f].palette_idx;
         cr = g->palette[p][c].r;
         cg = g->palette[p][c].g;
         cb = g->palette[p][c].b;

         // search *exact* same color in glb palette
         found = FALSE;
         for (i=0; (i < 256) && ( ! found); i++)
         {
            if ( (cr == glb_palette[i].r) &&
                 (cg == glb_palette[i].g) &&
                 (cb == glb_palette[i].b))
            {
               cmap[c] = i == 1 ? 0 : i;
               found = TRUE;
printf("%i\n", i);
fflush(stdout);

            }
         }
         if ( ! found)
         {
            printf("error : frame %i, color %i not found in glb palette\n", f, c);
            destroy_gif(g);
            exit(1);
         }
      }

      // remap all pixels using that temp colormap
      for (y=0; y < g->frame[f].height; y++)
      {
         for (x=0; x < g->frame[f].width; x++)
         {
            c = getpixel(g->frame[f].bmp, x, y);
            putpixel(g->frame[f].bmp, x, y, cmap[c]);
         }
      }
   }
}


// ==========================================================================
void draw_glb_cmap(int w, int h, int xw)
{
   int x, y, c;
   
   clear(glb_cmap);
   for (y=0; y < h;y++)
   {
      for (x=0; x < w; x++)
      {
         c = makecol(
               glb_colormap[y][x].r,
               glb_colormap[y][x].g,
               glb_colormap[y][x].b
            );
         rectfill(glb_cmap, x*xw, y*5, x*xw + 5, y*5 + 5, c);
      }
   }
}


// ==========================================================================
void draw_glb_colors()
{
   int i, x1, y1, p, c, g;
   int base_left = 300, base_up = 15, base_step = 20;
   int g_left = 460, g_width = 18, g_height=18, g_step = 20;

   glb_non_alleg[0].r = 170;
   glb_non_alleg[0].g = 170;
   glb_non_alleg[0].b = 170;
   glb_alleg_palette[0].r = 170 >> 2;
   glb_alleg_palette[0].g = 170 >> 2;
   glb_alleg_palette[0].b = 170 >> 2;
   for (i=1; i < 4; i++)
   {
      glb_non_alleg[i].r = glb_palette[i].r;
      glb_non_alleg[i].g = glb_palette[i].g;
      glb_non_alleg[i].b = glb_palette[i].b;
      glb_alleg_palette[i].r = glb_palette[i].r >> 2;
      glb_alleg_palette[i].g = glb_palette[i].g >> 2;
      glb_alleg_palette[i].b = glb_palette[i].b >> 2;
   }

   for (i=0; i < 28; i++)
   {
      if (i < 7)
      {
         textprintf(
            glb_buffer,
            font,
            base_left,
            base_up + i * base_step,
            makecol(255, 255, 255),
            "%s %3i : %s",
            glb_curr_col == i ? "-->" : "   ",
            glb_colors_1[i],
            glb_strings[i]
         );

         if (glb_curr_col == i)
         {
            textprintf(
               glb_buffer,
               font,
               725 - 8,
               14 + glb_colors_1[i] * 5,
               makecol(255, 255, 255),
               ">"
            );

            textprintf(
               glb_buffer,
               font,
               787,
               14 + glb_colors_1[i] * 5,
               makecol(255, 255, 255),
               "<"
            );
         }

         for (g=0; g < 12; g++)
         {
            x1 = g_left + g * g_step;
            y1 = (base_up + i * base_step) + 2 - (g_height / 2);
            p = glb_colors_1[i];
            c = makecol (
                   glb_colormap[p][g].r,
                   glb_colormap[p][g].g,
                   glb_colormap[p][g].b
                );
            rectfill(
               glb_buffer,
               x1,
               y1,
               x1 + g_width,
               y1 + g_height,
               c
            );
            glb_non_alleg[4 + i * 12 + g].r = glb_colormap[p][g].r;
            glb_non_alleg[4 + i * 12 + g].g = glb_colormap[p][g].g;
            glb_non_alleg[4 + i * 12 + g].b = glb_colormap[p][g].b;
            glb_alleg_palette[4 + i * 12 + g].r = glb_colormap[p][g].r >> 2;
            glb_alleg_palette[4 + i * 12 + g].g = glb_colormap[p][g].g >> 2;
            glb_alleg_palette[4 + i * 12 + g].b = glb_colormap[p][g].b >> 2;
         }
      }
      else
      {
         textprintf(
            glb_buffer,
            font,
            base_left,
            base_up + i * base_step + base_step,
            makecol(255, 255, 255),
            "%s %3i : %s",
            glb_curr_col == i ? "-->" : "   ",
            glb_colors_2[i - 7],
            glb_strings[i]
         );

         if (glb_curr_col == i)
         {
            textprintf(
               glb_buffer,
               font,
               725 - 8,
               14 + glb_colors_2[i - 7] * 5,
               makecol(255, 255, 255),
               ">"
            );

            textprintf(
               glb_buffer,
               font,
               787,
               14 + glb_colors_2[i - 7] * 5,
               makecol(255, 255, 255),
               "<"
            );
         }

         for (g=0; g < 8; g++)
         {
            x1 = g_left + g * g_step;
            y1 = (base_up + i * base_step + base_step) + 2 - (g_height / 2);
            p = glb_colors_2[i - 7];
            c = makecol (
                   glb_colormap[p][g*12/8].r,
                   glb_colormap[p][g*12/8].g,
                   glb_colormap[p][g*12/8].b
                );
            rectfill(
               glb_buffer,
               x1,
               y1,
               x1 + g_width,
               y1 + g_height,
               c
            );
            glb_non_alleg[88 + (i - 7) * 8 + g].r = glb_colormap[p][g].r;
            glb_non_alleg[88 + (i - 7) * 8 + g].g = glb_colormap[p][g].g;
            glb_non_alleg[88 + (i - 7) * 8 + g].b = glb_colormap[p][g].b;
            glb_alleg_palette[88 + (i - 7) * 8 + g].r = glb_colormap[p][g].r >> 2;
            glb_alleg_palette[88 + (i - 7) * 8 + g].g = glb_colormap[p][g].g >> 2;
            glb_alleg_palette[88 + (i - 7) * 8 + g].b = glb_colormap[p][g].b >> 2;
         }
      }
   }
}


// ==========================================================================
void draw_glb_colors_pst()
{
   int i, x1, y1, p, c, g;
   int base_left = 300, base_up = 15, base_step = 20;
   int g_left = 460, g_width = 13, g_height=18, g_step = 15;
   int base[4] = {16, 32, 64, 80};

   glb_non_alleg[0].r = 170;
   glb_non_alleg[0].g = 170;
   glb_non_alleg[0].b = 170;
   glb_alleg_palette[0].r = 170 >> 2;
   glb_alleg_palette[0].g = 170 >> 2;
   glb_alleg_palette[0].b = 170 >> 2;
   for (i=1; i < 128; i++)
   {
      glb_non_alleg[i].r = glb_palette[i].r;
      glb_non_alleg[i].g = glb_palette[i].g;
      glb_non_alleg[i].b = glb_palette[i].b;
      glb_alleg_palette[i].r = glb_palette[i].r >> 2;
      glb_alleg_palette[i].g = glb_palette[i].g >> 2;
      glb_alleg_palette[i].b = glb_palette[i].b >> 2;
   }

   // first 4 16-levels gradients
   for (i=0; i < 4; i++)
   {
      textprintf(
         glb_buffer,
         font,
         base_left,
         base_up + i * base_step,
         makecol(255, 255, 255),
         "%s %3i : %s",
         glb_curr_col == i ? "-->" : "   ",
         glb_colors_3[i],
         glb_strings_pst[i]
      );

      if (glb_curr_col == i)
      {
         textprintf(
            glb_buffer,
            font,
            725 - 8,
            14 + glb_colors_3[i] * 5,
            makecol(255, 255, 255),
            ">"
         );

         textprintf(
            glb_buffer,
            font,
            791,
            14 + glb_colors_3[i] * 5,
            makecol(255, 255, 255),
            "<"
         );
      }

      for (g=0; g < 16; g++)
      {
         x1 = g_left + g * g_step;
         y1 = (base_up + i * base_step) + 2 - (g_height / 2);
         p = glb_colors_3[i];
         c = makecol (
                glb_colormap[p][g * 2].r,
                glb_colormap[p][g * 2].g,
                glb_colormap[p][g * 2].b
             );
         rectfill(
            glb_buffer,
            x1,
            y1,
            x1 + g_width,
            y1 + g_height,
            c
         );
         glb_non_alleg[base[i] + g].r = glb_colormap[p][g * 2].r;
         glb_non_alleg[base[i] + g].g = glb_colormap[p][g * 2].g;
         glb_non_alleg[base[i] + g].b = glb_colormap[p][g * 2].b;
         glb_alleg_palette[base[i] + g].r = glb_colormap[p][g * 2].r >> 2;
         glb_alleg_palette[base[i] + g].g = glb_colormap[p][g * 2].g >> 2;
         glb_alleg_palette[base[i] + g].b = glb_colormap[p][g * 2].b >> 2;
      }
   }

   // now, 4 32-levels gradients
   base[0] = 128;
   base[1] = 160;
   base[2] = 192;
   base[3] = 224;
   base_up = 115;
   g_width = 5;
   g_step  = 7;
   
   for (i=0; i < 4; i++)
   {
      textprintf(
         glb_buffer,
         font,
         base_left,
         base_up + i * base_step,
         makecol(255, 255, 255),
         "%s %3i : %s",
         glb_curr_col == (4 + i) ? "-->" : "   ",
         glb_colors_3[4 + i],
         glb_strings_pst[4 + i]
      );

      if (glb_curr_col == (4 + i))
      {
         textprintf(
            glb_buffer,
            font,
            725 - 8,
            14 + glb_colors_3[4 + i] * 5,
            makecol(255, 255, 255),
            ">"
         );

         textprintf(
            glb_buffer,
            font,
            791,
            14 + glb_colors_3[4 + i] * 5,
            makecol(255, 255, 255),
            "<"
         );
      }

      for (g=0; g < 32; g++)
      {
         x1 = g_left + g * g_step;
         y1 = (base_up + i * base_step) + 2 - (g_height / 2);
         p = glb_colors_3[4 + i];
         c = makecol (
                glb_colormap[p][g].r,
                glb_colormap[p][g].g,
                glb_colormap[p][g].b
             );
         rectfill(
            glb_buffer,
            x1,
            y1,
            x1 + g_width,
            y1 + g_height,
            c
         );
         glb_non_alleg[base[i] + g].r = glb_colormap[p][g].r;
         glb_non_alleg[base[i] + g].g = glb_colormap[p][g].g;
         glb_non_alleg[base[i] + g].b = glb_colormap[p][g].b;
         glb_alleg_palette[base[i] + g].r = glb_colormap[p][g].r >> 2;
         glb_alleg_palette[base[i] + g].g = glb_colormap[p][g].g >> 2;
         glb_alleg_palette[base[i] + g].b = glb_colormap[p][g].b >> 2;
      }
   }
}


// ==========================================================================
void draw_help(void)
{
   textprintf(
      glb_buffer,
      font,
      50, 450,
      makecol(255, 255, 255),
      "Frame : %i",
      glb_curr_frame
   );

   textprintf(
      glb_buffer,
      font,
      50, 460,
      makecol(255, 255, 255),
      "Zoom  : %i%%",
      glb_curr_zoom
   );

   textprintf(
      glb_buffer,
      font,
      10, 490,
      makecol(255, 255, 255),
      "Up, Down           : Tint selection"
   );

   textprintf(
      glb_buffer,
      font,
      10, 500,
      makecol(255, 255, 255),
      "Left, Right        : Colormap on Tint"
   );

   textprintf(
      glb_buffer,
      font,
      10, 510,
      makecol(255, 255, 255),
      "Page Up, Page Down : Frame"
   );

   textprintf(
      glb_buffer,
      font,
      10, 520,
      makecol(255, 255, 255),
      "+, -               : Zoom in, out"
   );

   textprintf(
      glb_buffer,
      font,
      10, 540,
      makecol(255, 255, 255),
      "S                  : Save into .bmp"
   );

   textprintf(
      glb_buffer,
      font,
      10, 560,
      makecol(255, 255, 255),
      "Esc                : Quit"
   );
}


// ==========================================================================
void draw_buffer(GIF_ANIM_S * g, GM_ENUM game)
{
   int x0, y0, w, h;


   clear(glb_buffer);
//   clear_to_color(glb_sub_preview, makecol(0,255,255));

   blit(glb_cmap, glb_buffer, 0, 0, 725, 15, glb_cmap->w, glb_cmap->h);

   if (game == GM_PST)
      draw_glb_colors_pst();
   else
      draw_glb_colors();

   set_palette(glb_alleg_palette);
   clear(glb_sprite);
   draw_sprite(
      glb_sprite,
      g->frame[glb_curr_frame].bmp,
      g->frame[glb_curr_frame].left_position, g->frame[glb_curr_frame].top_position
   );

   w  = glb_sprite->w * glb_curr_zoom / 100;
   h  = glb_sprite->h * glb_curr_zoom / 100;
   x0 = (glb_sub_preview->w - w) / 2;
   y0 = (glb_sub_preview->h - h) / 2;
   stretch_blit(
      glb_sprite,
      glb_sub_preview,
      0, 0,
      glb_sprite->w,
      glb_sprite->h,
      x0, y0,
      w, h
   );

   draw_help();
}


// ==========================================================================
// allegro lost the 2 lowest bits, so hex-edit the BMP to put back the
// exact palette
void modify_bmp_palette(char * name)
{
   FILE          * in;
   int           i;
   unsigned long offset;

   in = fopen(name, "rb+");
   if (in == NULL)
   {
      printf("modify_bmp_palette() warning : can't open <%s>\n", name);
      return;
   }
   fseek(in, 14, SEEK_SET);
   fread( & offset, 4, 1, in);
   fseek(in, offset - 5, SEEK_CUR);
   for (i=0; i<256; i++)
   {
      fputc(0, in);
      fputc(glb_non_alleg[i].b, in);
      fputc(glb_non_alleg[i].g, in);
      fputc(glb_non_alleg[i].r, in);
   }
   fclose(in);
}


// ==========================================================================
// allegro lost the 2 lowest bits, so hex-edit the PCX to put back the
// exact palette
void modify_pcx_palette(char * name)
{
   FILE * in;
   int  i;

   in = fopen(name, "rb+");
   if (in == NULL)
   {
      printf("modify_pcx_palette() warning : can't open <%s>\n", name);
      return;
   }
   fseek(in, -768, SEEK_END);
   for (i=0; i<256; i++)
   {
      fputc(glb_non_alleg[i].r, in);
      fputc(glb_non_alleg[i].g, in);
      fputc(glb_non_alleg[i].b, in);
   }
   fclose(in);
}


// ==========================================================================
void main(int argc, char **argv)
{
   GIF_ANIM_S * gif_anim;
   char       * tmp, strtmp[256];
   int        size, i, x, y, p, c;
   int        scr_w = 800, scr_h = 600;
   FILE       * in, * out;
   int        rest_milisec_delay = 75, mygfxmode, max_zoom = 1000, step;
   char       * palshift_name = "last_palshift.bin";
   enum       {OF_BMP, OF_PCX} output_format;
   GM_ENUM    game;
   int        rest_zoom_milisec_delay = 33, w, h;
   BITMAP     * save_bmp, * cmap_bitmap;
   char       * cmap_bg2_name = "cmaps_bg2_12.bmp",
              * cmap_pst_name = "cmaps_pst_32.bmp",
              * cmap_this_game,
              * pal_bg2_name  = "pal_bg2.bin",
              * pal_pst_name  = "pal_pst.bin",
              * pal_this_game;
   int        nb_tint_max, nb_cmap_max;
   

   allegro_init();
   printf("ALLEGRO_PLATFORM_STR = %s\n", ALLEGRO_PLATFORM_STR);
   printf("allegro_id           = %s\n\n", allegro_id);

   if (argc >= 2)
   {
      // chdir
      size = strlen(argv[0]);
      tmp = (char *) malloc (size);
      if (tmp == NULL)
      {
         printf("can't allocate %i bytes for tmp\n", size);
         exit(0);
      }
      strcpy(tmp, argv[0]);
      i = size - 1;
      while ((i > 0) && (argv[0][i] != '\\'))
         i--;
      tmp[i] = 0x00;
      printf("chdir(%s)\n", tmp);
      chdir(tmp);
      free(tmp);

      // -pcx parameter ?
      output_format = OF_BMP;
      for (i=1; i < argc; i++)
      {
         if (stricmp(argv[i], "-pcx") == 0)
            output_format = OF_PCX;
      }

      // -pst parameter ? (PlaneScape : Tourment)
      game           = GM_BG2;
      cmap_this_game = cmap_bg2_name;
      pal_this_game  = pal_bg2_name;
      nb_tint_max    = 27;
      nb_cmap_max    = 116;
      for (i=1; i < argc; i++)
      {
         if (stricmp(argv[i], "-pst") == 0)
         {
            game           = GM_PST;
            cmap_this_game = cmap_pst_name;
            pal_this_game  = pal_pst_name;
            nb_tint_max    = 7;
            nb_cmap_max    = 79;
         }
      }

      // load last palshift.bin
      in = fopen(palshift_name, "rb");
      if (in != NULL)
      {
         fread(glb_colors_1, 1, sizeof(glb_colors_1), in);
         fread(glb_colors_2, 1, sizeof(glb_colors_2), in);
         fread(glb_colors_3, 1, sizeof(glb_colors_3), in);
         fclose(in);
      }
      
      // load gif
      set_color_depth(8);

      gif_anim = load_gif(argv[1]);
      if (gif_anim == NULL)
      {
         printf("can't load %s\n", argv[1]);
         exit(1);
      }

      // load global palette
      printf("loading global palette <%s>\n", pal_this_game);
      fflush(stdout);
      in = fopen(pal_this_game, "rb");
      if (in == NULL)
      {
         destroy_gif(gif_anim);
         printf("can't open <%s>\n", pal_this_game);
         exit(1);
      }
      for (i=0; i < 256; i++)
      {
         glb_palette[i].r = fgetc(in);
         glb_palette[i].g = fgetc(in);
         glb_palette[i].b = fgetc(in);
      }
      fclose(in);

      // prepare screen & buffer
      // necessary before loading a truecolor bitmap
      set_color_depth(32);
      mygfxmode = GFX_AUTODETECT_WINDOWED;
      if (set_gfx_mode(mygfxmode, scr_w, scr_h, 0, 0) < 0)
      {
         set_color_depth(24);
         if (set_gfx_mode(mygfxmode, scr_w, scr_h, 0, 0) < 0)
         {
            destroy_gif(gif_anim);
            printf("error : %s\n", allegro_error);
            exit(1);
         }
      }
      
      // load colormaps gradients
      printf("loading colormaps gradients <%s>\n", cmap_this_game);
      fflush(stdout);
      cmap_bitmap = load_bitmap(cmap_this_game, NULL);
      if (cmap_bitmap == NULL)
      {
         destroy_gif(gif_anim);
         printf("can't read <%s>\n", cmap_this_game);
         exit(1);
      }
      w = 12;
      h = 116;
      if (game == GM_PST)
      {
         w = 32;
         h = 79;
      }
      memset(glb_colormap, 0, sizeof(glb_colormap));
      for (y=0; y < h; y++)
      {
         for (x=0; x < w; x++)
         {
            c = getpixel(cmap_bitmap, x, y);
            glb_colormap[y][x].r = getr(c);
            glb_colormap[y][x].g = getg(c);
            glb_colormap[y][x].b = getb(c);
         }
      }
      destroy_bitmap(cmap_bitmap);

      // remap pixels of all frames from local palette to global palette
      printf("remaping pixels\n");
      fflush(stdout);
      remap_pixels(gif_anim);

      // screen buffer
      glb_buffer = create_bitmap(scr_w, scr_h);
      if (glb_buffer == NULL)
      {
         destroy_gif(gif_anim);
         printf("can't allocate glb_buffer\n");
         exit(1);
      }

      // screen sub bitmap, for sprite preview
      glb_sub_preview = create_sub_bitmap(glb_buffer, 0, 0, 300, 450);
      if (glb_sub_preview == NULL)
      {
         destroy_gif(gif_anim);
         destroy_bitmap(glb_buffer);
         printf("can't allocate glb_sub_preview\n");
         exit(1);
      }

      // color map buffer
      glb_cmap = create_bitmap(64, 580); // 4*16, 5*116
      if (glb_cmap == NULL)
      {
         destroy_gif(gif_anim);
         destroy_bitmap(glb_sub_preview);
         destroy_bitmap(glb_buffer);
         printf("can't allocate glb_cmap\n");
         exit(1);
      }
      draw_glb_cmap(w, h, game == GM_PST ? 2 : 5);

      // sprite buffer, copy of the 8bpp sprite in the current video mode,
      // to allow stretch_blit() to works
      glb_sprite = create_bitmap(gif_anim->width, gif_anim->height);
      if (glb_sprite == NULL)
      {
         destroy_gif(gif_anim);
         destroy_bitmap(glb_sub_preview);
         destroy_bitmap(glb_buffer);
         destroy_bitmap(glb_cmap);
         printf("can't allocate glb_sprite\n");
         exit(1);
      }

      // sprite buffer 8bpp
      glb_sprite_8bpp = create_bitmap_ex(8, gif_anim->width, gif_anim->height);
      if (glb_sprite_8bpp == NULL)
      {
         destroy_gif(gif_anim);
         destroy_bitmap(glb_sub_preview);
         destroy_bitmap(glb_buffer);
         destroy_bitmap(glb_cmap);
         destroy_bitmap(glb_sprite);
         printf("can't allocate glb_sprite_8bpp\n");
         exit(1);
      }

      // search max possible zoom, by increment of 10
      glb_curr_zoom = 100;
      for (i=10; i < max_zoom; i += 10)
      {
         if ( ((glb_sprite->w * i / 100) < glb_sub_preview->w) &&
              ((glb_sprite->h * i / 100) < glb_sub_preview->h)
            )
         {
            glb_curr_zoom = i;
         }
      }

      // last init
      install_keyboard();
      install_timer();

      // go
      while ( ! key[KEY_ESC])
      {
         draw_buffer(gif_anim, game);
         vsync();
         blit(glb_buffer, screen, 0, 0, 0, 0, scr_w, scr_h);

         // UP = previous palette tint
         if (key[KEY_UP] && (glb_curr_col > 0))
         {
            rest(rest_milisec_delay);
            glb_curr_col--;
         }

         // DOWN = next palette tint
         if (key[KEY_DOWN] && (glb_curr_col < nb_tint_max))
         {
            rest(rest_milisec_delay);
            glb_curr_col++;
         }

         // LEFT = previous colormap
         if (game == GM_PST)
         {
            p = glb_colors_3[glb_curr_col];
            if (key[KEY_LEFT] && (p > 0))
            {
               rest(rest_milisec_delay);
               glb_colors_3[glb_curr_col]--;
            }
         }
         else
         {
            c = glb_curr_col < 7 ? 0 : 1;
            p = c ? glb_colors_2[glb_curr_col - 7] : glb_colors_1[glb_curr_col];
            if (key[KEY_LEFT] && (p > 0))
            {
               rest(rest_milisec_delay);
               if (c)
                  glb_colors_2[glb_curr_col - 7]--;
               else
                  glb_colors_1[glb_curr_col]--;
            }
         }

         // RIGHT = next colormap
         if (game == GM_PST)
         {
            p = glb_colors_3[glb_curr_col];
            if (key[KEY_RIGHT] && (p < (nb_cmap_max - 1)))
            {
               rest(rest_milisec_delay);
               glb_colors_3[glb_curr_col]++;
            }
         }
         else
         {
            c = glb_curr_col < 7 ? 0 : 1;
            p = c ? glb_colors_2[glb_curr_col - 7] : glb_colors_1[glb_curr_col];
            if (key[KEY_RIGHT] && (p < (nb_cmap_max - 1)))
            {
               rest(rest_milisec_delay);
               if (c)
                  glb_colors_2[glb_curr_col - 7]++;
               else
                  glb_colors_1[glb_curr_col]++;
            }
         }

         // PAGE_UP = previous frame
         if (key[KEY_PGUP])
         {
            rest(rest_milisec_delay);
            glb_curr_frame--;
            if (glb_curr_frame < 0)
               glb_curr_frame = gif_anim->num_frames - 1;
         }     

         // PAGE_DOWN = next frame
         if (key[KEY_PGDN])
         {
            rest(rest_milisec_delay);
            glb_curr_frame++;
            if (glb_curr_frame >= gif_anim->num_frames)
               glb_curr_frame = 0;
         }

         // - = zoom out
         step = 10;
         if (key[KEY_LSHIFT] || key[KEY_RSHIFT])
            step = 1;
         if (key[KEY_MINUS_PAD] || key[KEY_MINUS])
         {

            if (glb_curr_zoom > step)
               glb_curr_zoom -= step;
            rest(rest_zoom_milisec_delay);
         }

         // + = zoom in
         if (key[KEY_PLUS_PAD] || key[KEY_EQUALS])
         {
            glb_curr_zoom += step;
            rest(rest_zoom_milisec_delay);
         }

         // HOME = zoom 100%
         if (key[KEY_HOME])
         {
            if ((glb_curr_zoom % 100) != 0)
            {
               if ((glb_curr_zoom % 100) >= 50)
                  glb_curr_zoom += (100 - (glb_curr_zoom % 100));
               else
               glb_curr_zoom -= (glb_curr_zoom % 100);
            }
            else
            {
               if (glb_curr_zoom == 100)
                  glb_curr_zoom = 200;
               else  if (glb_curr_zoom == 200)
                  glb_curr_zoom = 300;
               else  if (glb_curr_zoom == 300)
                  glb_curr_zoom = 400;
               else  if (glb_curr_zoom == 400)
                  glb_curr_zoom = 500;
               else  if (glb_curr_zoom == 500)
                  glb_curr_zoom = 600;
               else  if (glb_curr_zoom == 600)
                  glb_curr_zoom = 700;
               else  if (glb_curr_zoom == 700)
                  glb_curr_zoom = 800;
               else  if (glb_curr_zoom == 800)
                  glb_curr_zoom = 900;
               else  if (glb_curr_zoom == 900)
                  glb_curr_zoom = 1000;
               else
                  glb_curr_zoom = 100;
            }
            while (key[KEY_HOME])
            {}
         }

         // no zoom out of range
         if (glb_curr_zoom < step)
            glb_curr_zoom = step;

         if (glb_curr_zoom > max_zoom)
            glb_curr_zoom = max_zoom;

         // S  = save frames with current palette
         if (key[KEY_S])
         {
            // save 
            w = gif_anim->width  * glb_curr_zoom / 100;
            h = gif_anim->height * glb_curr_zoom / 100;
            if (w < 1) w = 1;
            if (h < 1) h = 1;
            save_bmp = create_bitmap_ex(8, w, h);
            if (save_bmp == NULL)
            {
               destroy_bitmap(glb_sub_preview);
               destroy_gif(gif_anim);
               destroy_bitmap(glb_buffer);
               destroy_bitmap(glb_cmap);
               destroy_bitmap(glb_sprite);
               destroy_bitmap(glb_sprite_8bpp);
               printf("can't create save_bmp %i * %i\n", w, h);
               exit(1);
            }
            for (i=0; i < gif_anim->num_frames; i++)
            {
               sprintf(
                  strtmp,
                  "frame%03i%s",
                  i,
                  output_format == OF_PCX ? ".pcx" : ".bmp"
               );

               clear(glb_sprite_8bpp);
               draw_sprite(
                  glb_sprite_8bpp,
                  gif_anim->frame[i].bmp,
                  gif_anim->frame[i].left_position,
                  gif_anim->frame[i].top_position
               );
               stretch_blit(
                  glb_sprite_8bpp,
                  save_bmp,
                  0, 0,
                  glb_sprite_8bpp->w,
                  glb_sprite_8bpp->h,
                  0, 0,
                  w, h
               );

               save_bitmap(strtmp, save_bmp, glb_alleg_palette);

               // hack this file to have the accurate palette
               if (output_format == OF_PCX)
                  modify_pcx_palette(strtmp);
               else
                  modify_bmp_palette(strtmp);
            }
            destroy_bitmap(save_bmp);

            // save current palette shifting information
            out = fopen(palshift_name, "wb");
            if (out != NULL)
            {
               fwrite(glb_colors_1, 1, sizeof(glb_colors_1), out);
               fwrite(glb_colors_2, 1, sizeof(glb_colors_2), out);
               fwrite(glb_colors_3, 1, sizeof(glb_colors_3), out);
               fclose(out);
            }

            while (key[KEY_S])
            {}
         }

      }

      // end
      destroy_bitmap(glb_sub_preview);
      destroy_gif(gif_anim);
      destroy_bitmap(glb_buffer);
      destroy_bitmap(glb_cmap);
      destroy_bitmap(glb_sprite);
      destroy_bitmap(glb_sprite_8bpp);
   }
   else
   {
      printf("syntaxe : bam_color_picker.exe <file.gif>\n");
      exit(0);
   }
}
END_OF_MAIN();
